#include <string.h>
#include <stdbool.h>
#include "simpletools.h"
#include "fdserial.h"
#include "gcode_struct.h"
#include "processor.h"

fdserial *parser;

GCODE_STRUCT current_gcode;

int main(void)
{
	current_gcode.g_num = 20;
	current_gcode.m_num = 20;
	current_gcode.t_num = 20;
	current_gcode.s_num = 20;
	current_gcode.p_num = 20;

	current_gcode.x_num = 1.00;
	current_gcode.y_num = 1.00;
	current_gcode.z_num = 1.00;
	current_gcode.e_num = 1.00;
	current_gcode.f_num = 1.00;

	current_gcode.x_travel = 2.00;
	current_gcode.y_travel = 2.00;
	current_gcode.z_travel = 2.00;
	current_gcode.e_travel = 2.00;

	current_gcode.x_dir = 3; 
	current_gcode.x_start_stop_speed = 100;
	current_gcode.x_total_steps = 2000;
	current_gcode.x_ramp_up_steps = 50;
	current_gcode.x_running_steps = 1900;
	current_gcode.x_ramp_down_steps = 50;
	current_gcode.x_ramp_inc_dec = 10;

	current_gcode.y_dir = 3;
	current_gcode.y_start_stop_speed = 100;
	current_gcode.y_total_steps = 2000;
	current_gcode.y_ramp_up_steps = 50;
	current_gcode.y_running_steps = 1900;
	current_gcode.y_ramp_down_steps = 50;
	current_gcode.y_ramp_inc_dec = 10;

	current_gcode.z_dir = 3;
	current_gcode.z_start_stop_speed = 100;
	current_gcode.z_total_steps = 2000;
	current_gcode.z_ramp_up_steps = 50;
	current_gcode.z_running_steps = 1900;
	current_gcode.z_ramp_down_steps = 50;
	current_gcode.z_ramp_inc_dec = 10;

	current_gcode.e_dir = 3;
	current_gcode.e_start_stop_speed = 100;
	current_gcode.e_total_steps = 2000;
	current_gcode.e_ramp_up_steps = 50;
	current_gcode.e_running_steps = 1900;
	current_gcode.e_ramp_down_steps = 50;
	current_gcode.e_ramp_inc_dec = 10;

	serial_processor_init();    
	parser = fdserial_open(1, 3, 0, 115200);
	waitcnt(CNT + CLKFREQ);

	/////////////////////////////////////////////////////////////
	// Insert test code here
	/////////////////////////////////////////////////////////////

	// Copy GCODE_STRUCT into char array for sending
	char send_struct_array[sizeof(GCODE_STRUCT)];
	memcpy(send_struct_array, &current_gcode, sizeof(GCODE_STRUCT));				

	print("Size of current_gcode: %u\n", sizeof(GCODE_STRUCT));
	print("Size of send_struct_array: %u\n", sizeof(send_struct_array));

	fdserial_txChar(parser, '<');

	for(size_t i = 0; i < sizeof(GCODE_STRUCT); i++)
	{
		while(fdserial_txEmpty(parser) == 0){}

		fdserial_txChar(parser, send_struct_array[i]);
	}

	fdserial_txChar(parser, '>');

	while(gcode_struct_received == false){}

	gcode_struct_received = false;

	/////////////////////////////////////////////////////////////

	print("sent_gcode.g_num = %u\n", sent_gcode.g_num);
	print("sent_gcode.m_num = %u\n", sent_gcode.m_num);
	print("sent_gcode.t_num = %u\n", sent_gcode.t_num);
	print("sent_gcode.s_num = %u\n", sent_gcode.s_num);
	print("sent_gcode.p_num = %u\n", sent_gcode.p_num);

	print("sent_gcode.x_num = %5.2f\n", sent_gcode.x_num);
	print("sent_gcode.y_num = %5.2f\n", sent_gcode.y_num);
	print("sent_gcode.z_num = %5.2f\n", sent_gcode.z_num);
	print("sent_gcode.e_num = %5.2f\n", sent_gcode.e_num);
	print("sent_gcode.f_num = %5.2f\n", sent_gcode.f_num);

	print("sent_gcode.x_travel = %5.2f\n", sent_gcode.x_travel);
	print("sent_gcode.y_travel = %5.2f\n", sent_gcode.y_travel);
	print("sent_gcode.z_travel = %5.2f\n", sent_gcode.z_travel);
	print("sent_gcode.e_travel = %5.2f\n", sent_gcode.e_travel);

	print("sent_gcode.x_dir = %u\n", sent_gcode.x_dir);
	print("sent_gcode.x_start_stop_speed = %u\n", sent_gcode.x_start_stop_speed);
	print("sent_gcode.x_total_steps = %u\n", sent_gcode.x_total_steps);
	print("sent_gcode.x_ramp_up_steps = %u\n", sent_gcode.x_ramp_up_steps);
	print("sent_gcode.x_running_steps = %u\n", sent_gcode.x_running_steps);
	print("sent_gcode.x_ramp_down_steps = %u\n", sent_gcode.x_ramp_down_steps);
	print("sent_gcode.x_ramp_inc_dec = %u\n", sent_gcode.x_ramp_inc_dec);

	print("sent_gcode.y_dir = %u\n", sent_gcode.y_dir);
	print("sent_gcode.y_start_stop_speed = %u\n", sent_gcode.y_start_stop_speed);
	print("sent_gcode.y_total_steps = %u\n", sent_gcode.y_total_steps);
	print("sent_gcode.y_ramp_up_steps = %u\n", sent_gcode.y_ramp_up_steps);
	print("sent_gcode.y_running_steps = %u\n", sent_gcode.y_running_steps);
	print("sent_gcode.y_ramp_down_steps = %u\n", sent_gcode.y_ramp_down_steps);
	print("sent_gcode.y_ramp_inc_dec = %u\n", sent_gcode.y_ramp_inc_dec);

	print("sent_gcode.z_dir = %u\n", sent_gcode.z_dir);
	print("sent_gcode.z_start_stop_speed = %u\n", sent_gcode.z_start_stop_speed);
	print("sent_gcode.z_total_steps = %u\n", sent_gcode.z_total_steps);
	print("sent_gcode.z_ramp_up_steps = %u\n", sent_gcode.z_ramp_up_steps);
	print("sent_gcode.z_running_steps = %u\n", sent_gcode.z_running_steps);
	print("sent_gcode.z_ramp_down_steps = %u\n", sent_gcode.z_ramp_down_steps);
	print("sent_gcode.z_ramp_inc_dec = %u\n", sent_gcode.z_ramp_inc_dec);

	print("sent_gcode.e_dir = %u\n", sent_gcode.e_dir);
	print("sent_gcode.e_start_stop_speed = %u\n", sent_gcode.e_start_stop_speed);
	print("sent_gcode.e_total_steps = %u\n", sent_gcode.e_total_steps);
	print("sent_gcode.e_ramp_up_steps = %u\n", sent_gcode.e_ramp_up_steps);
	print("sent_gcode.e_running_steps = %u\n", sent_gcode.e_running_steps);
	print("sent_gcode.e_ramp_down_steps = %u\n", sent_gcode.e_ramp_down_steps);
	print("sent_gcode.e_ramp_inc_dec = %u", sent_gcode.e_ramp_inc_dec);
 
	return 0;
}

